﻿Imports System.Drawing.Printing
Imports C1.Win.C1Document
Imports C1.Win.C1Ribbon

Public Class PrintDemo
    Dim dialog As New PrintDialog
    Friend WithEvents btnPrintDialog As New RibbonButton()
    Friend WithEvents btnPrintDirect As New RibbonButton()

    Private Sub PrintDemo_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        C1FlexReport1.Load("../../Invoice.flxr", "Invoice")
        C1FlexViewer1.RibbonElements.Print.Visible = False
        btnPrintDialog.Text = "Print"
        btnPrintDialog.LargeImage = C1FlexViewer1.RibbonElements.Print.LargeImage
        C1FlexViewer1.Ribbon.Tabs(0).Groups(4).Items.Add(btnPrintDialog)
        C1FlexViewer1.DocumentSource = C1FlexReport1

        C1FlexViewer2.RibbonElements.Print.Visible = False
        btnPrintDirect.Text = "Print"
        btnPrintDirect.LargeImage = C1FlexViewer1.RibbonElements.Print.LargeImage
        C1FlexViewer2.Ribbon.Tabs(0).Groups(4).Items.Add(btnPrintDirect)
        C1FlexViewer2.DocumentSource = C1FlexReport1
    End Sub

    Private Sub btnPrintDialog_Click(sender As Object, e As EventArgs) Handles btnPrintDialog.Click
        dialog.AllowSelection = True
        dialog.AllowSomePages = True
        Dim printer As String = "Microsoft XPS Document Writer"
        Dim options As New PrinterSettings()

        'setting PrinterName
        options.PrinterName = printer

        'setting No. of Copies
        options.Copies = 2

        'setting Print Range
        options.PrintRange = PrintRange.SomePages
        options.FromPage = 5
        options.ToPage = 6

        dialog.PrinterSettings = options

        'setting PaperSource
        Dim source As New PaperSource()
        source.SourceName = dialog.PrinterSettings.PaperSources(0).ToString()
        options.DefaultPageSettings.PaperSource = source
        'setting PaperSize
        For i As Integer = 0 To options.PaperSizes.Count - 1
            If (options.PaperSizes(i).Kind = PaperKind.A3) Then
                options.DefaultPageSettings.PaperSize = options.PaperSizes(i)
            End If
        Next
        If dialog.ShowDialog() = DialogResult.OK Then
            C1FlexReport1.Print(options)
        End If
    End Sub

    Private Sub btnDirectPrint_Click(sender As Object, e As EventArgs) Handles btnPrintDirect.Click
        Dim printer As String = "Microsoft XPS Document Writer"
        Dim options As New C1PrintOptions()
        options.PrinterSettings = New PrinterSettings()
        options.PageSettings = New PageSettings()

        'setting PrinterName
        options.PrinterSettings.PrinterName = printer

        'setting No. of Copies
        options.PrinterSettings.Copies = 2

        'setting Print Range
        options.PrinterSettings.PrintRange = PrintRange.SomePages
        options.PrinterSettings.FromPage = 3
        options.PrinterSettings.ToPage = 4

        'setting PaperSource
        Dim source As New PaperSource()
        source.SourceName = "SourceName"
        options.PrinterSettings.DefaultPageSettings.PaperSource = source

        'setting PaperSize
        For i As Integer = 0 To options.PrinterSettings.PaperSizes.Count - 1
            If (options.PrinterSettings.PaperSizes(i).Kind = PaperKind.A3) Then
                options.PageSettings.PaperSize = options.PrinterSettings.PaperSizes(i)
            End If
        Next
        C1FlexReport1.Print(options)
    End Sub
End Class
